class MovementTimer
{
  Player player;
  long start;
  long end;
  long previous;
  float xmov, ymov;
  
  public MovementTimer(Player player, long start, long end, float xmov, float ymov)
  {
   this.start = start;
   this.previous = start;
   this.end = end; 
   this.xmov = xmov;
   this.ymov = ymov;
   this.player = player;
   player.movements.add(this);
  }
  
  //return true if it should be detached
  public boolean update(long current)
  {
      boolean readyToRemove = false;
      if (current <= start)
      {
        return false; //do nothing, we are not ready to change
      }
      
      if (current >= end)
      {
        //move to end, then detach myself from the player
        current = end;
        readyToRemove = true;  
      }
      
      float lastTimePercentage = (float)(previous - start) / (float)(end - start);
      float thisTimePercentage = (float)(current - start) / (float)(end - start);
      float percDiff = thisTimePercentage - lastTimePercentage;
 
      player.xpos += (xmov * percDiff);
      player.ypos += (ymov * percDiff);
      
      previous = current;
      return readyToRemove;   
  }
  
  
}
